/*
 * Copyright The string doesn't match the expected date/time/date-time format. The string to parse was: "2022年2月26日". The expected format was: "MMM d, y".
The nested reason given follows:
Unparseable date: "2022年2月26日"

----
FTL stack trace ("~" means nesting-related):
	- Failed at: ${date?date?string("yyyy")}  [in template "Templates/Licenses/license-apache20.txt" at line 4, column 27]
	- Reached through: #include "${project.licensePath}"  [in template "Templates/NetBeansModuleDevelopment-files/templateTopComponent637.java" at line 24, column 1]
---- Peter.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package hk.quantr.netbeans.verilog.window.graph;

import hk.quantr.netbeans.ModuleLib;
import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import org.antlr.v4.runtime.RuntimeMetaData;
import org.apache.commons.io.FileUtils;
import org.netbeans.api.project.FileOwnerQuery;
import org.netbeans.api.project.Project;
import org.netbeans.api.project.ui.OpenProjects;
import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.filesystems.FileObject;
import org.openide.windows.TopComponent;
import org.openide.util.NbBundle.Messages;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(
		dtd = "-//hk.quantr.netbeans.verilog.window.graph//GraphWindow//EN",
		autostore = false
)
@TopComponent.Description(
		preferredID = "GraphWindowTopComponent",
		iconBase = "hk/quantr/netbeans/verilog/verilog.png",
		persistenceType = TopComponent.PERSISTENCE_ALWAYS
)
@TopComponent.Registration(mode = "editor", openAtStartup = false)
@ActionID(category = "Window", id = "hk.quantr.netbeans.verilog.window.graph.GraphWindowTopComponent")
@ActionReference(path = "Menu/Window" /*, position = 333 */)
@TopComponent.OpenActionRegistration(
		displayName = "#CTL_GraphWindowAction",
		preferredID = "GraphWindowTopComponent"
)
@Messages({
	"CTL_GraphWindowAction=Graph",
	"CTL_GraphWindowTopComponent=Graph",
	"HINT_GraphWindowTopComponent=This is a verilog graph window"
})
public final class GraphWindowTopComponent extends TopComponent {

	public GraphWindowTopComponent() {
		initComponents();
		setName(Bundle.CTL_GraphWindowTopComponent());
		setToolTipText(Bundle.HINT_GraphWindowTopComponent());

//		graphTopComponent1.topModuleComboBox.removeAllItems();
//		graphTopComponent1.topModuleComboBox.repaint();
////		if (projectComboBox.getSelectedItem() != null) {
////			File folder = new File(((Project) projectComboBox.getSelectedItem()).getProjectDirectory().getPath());
//		File folder = new File(OpenProjects.getDefault().getOpenProjects()[0].getProjectDirectory().getPath());
//		ModuleLib.log(folder.getAbsolutePath());
//
//		List<File> files = new ArrayList(FileUtils.listFiles(folder, new String[]{"v"}, false));
//		files.addAll(new ArrayList(FileUtils.listFiles(new File(folder.getAbsolutePath() + File.separator + "src"), new String[]{"v"}, false)));
//		Comparator<File> comparator = new Comparator<File>() {
//			@Override
//			public int compare(File o1, File o2) {
//				return o1.getName().compareTo(o2.getName());
//			}
//		};
//		Collections.sort(files, comparator);
//		for (File file : files) {
//			graphTopComponent1.topModuleComboBox.addItem(file);
//		}
		System.out.println("Antlr " + RuntimeMetaData.VERSION);
		TopComponent activeC = TopComponent.getRegistry().getActivated();
		if (activeC == null) {
			return;
		}
		FileObject dataLookup = activeC.getLookup().lookup(FileObject.class);
		if (dataLookup == null) {
			return;
		}
		Project pro = FileOwnerQuery.getOwner(dataLookup);
		String path = pro.getProjectDirectory().getPath();
		graphTopComponent1.loadAllVerilog(new File(path + File.separator + "src/quantr_i.v"));
//		}
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        graphTopComponent1 = new hk.quantr.veriloggraph.QuantrVerilogGraphPanel();

        setLayout(new java.awt.BorderLayout());
        add(graphTopComponent1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    public hk.quantr.veriloggraph.QuantrVerilogGraphPanel graphTopComponent1;
    // End of variables declaration//GEN-END:variables
	@Override
	public void componentOpened() {
		// TODO add custom code on component opening
	}

	@Override
	public void componentClosed() {
		// TODO add custom code on component closing
	}

	void writeProperties(java.util.Properties p) {
		// better to version settings since initial version as advocated at
		// http://wiki.apidesign.org/wiki/PropertyFiles
		p.setProperty("version", "1.0");
		// TODO store your settings
	}

	void readProperties(java.util.Properties p) {
		String version = p.getProperty("version");
		// TODO read your settings according to their version
	}
}
